#!/bin/sh

. ./load.cgi

BASE_DIR="/local/data"
LOCAL_APP_DIR="/local/root"

SYSUPDATE=/local/sysupdate.sh
ERROR=1

if [ "$REQUEST_METHOD" = "POST" ]; then

  # dump the data
  TMPOUT=/local/fwupdate
  cat > $TMPOUT

  # extract the file name if the file is a receipe zip 
  FILENAME=`grep 'Content-Disposition: form-data; name=' | grep 'filename="' $TMPOUT | cut -d\; -f3 | cut -d\" -f2`
    
  # extract the type of upload
  SYSUPD=`head $TMPOUT | grep -c name=\"SYSUPD\"`
  HMI=`head $TMPOUT | grep -c name=\"HMI\"` 
  FCRTS=`head $TMPOUT | grep -c name=\"FCRTS\"` 
  PLC=`head $TMPOUT | grep -c name=\"PLC\"` 
  CROSSTBL=`head $TMPOUT | grep -c name=\"CROSSTBL\"` 
  TAGTBL=`head $TMPOUT | grep -c name=\"TAGTBL\"` 
  ALARMTBL=`head $TMPOUT | grep -c name=\"ALARMTBL\"` 
  ATNCFG=`head $TMPOUT | grep -c name=\"ATNCFG\"` 
  CFGTBL=`head $TMPOUT | grep -c name=\"CFGTBL\"` 
  RCPTBL=`head $TMPOUT | grep -c name=\"RCPTBL\"` 
  RCPZIP=`head $TMPOUT | grep -c name=\"RCPZIP\"` 
  CFGZIP=`head $TMPOUT | grep -c name=\"CFGZIP\"` 
  LOGSTBL=`head $TMPOUT | grep -c name=\"LOGSTBL\"` 
  TRENDTBL=`head $TMPOUT | grep -c name=\"TRENDTBL\"` 
  SPLASH=`head $TMPOUT | grep -c name=\"SPLASH\"` 
  PATHCFG=`head $TMPOUT | grep -c name=\"PATHCFG\"` 

  # ship the first 4 lines and the lats line and the last \r
  cat $TMPOUT | sed '1,4d' | sed '$d' | sed '$s/.$//' > $TMPOUT.1

  if [ -s $TMPOUT.1 ]
  then

#    if [ "$RCPTBL" != "1" ] && [ "$RCPZIP" != "1" ] && [ "$LOGSTBL" != "1" ] && [ "$TRENDTBL" != "1" ]; then
		/etc/rc.d/init.d/autoexec stop > /dev/null 2>&1
	if [ -x /local/root/splash ]
	then
		/local/root/splash --text "Updating ..." --dimension 42 -qws &
	fi
#    fi

  # SYSUPDATE
  if [ "$SYSUPD" == "1" ]
  then
	MSG="system update"
  	if  [ -s $TMPOUT.1 ]
	then
		mv $TMPOUT.1 $SYSUPDATE
		chmod 754 $SYSUPDATE
	  	$SYSUPDATE
		ERROR=$?
		rm -rf $SYSUPDATE
	else
		ERROR=1
	fi
  fi

  # HMI
  if [ "$HMI" = "1" ]; then
     MSG="hmi update"
     if [ -s $TMPOUT.1 ]; then
        mv $TMPOUT.1 $LOCAL_APP_DIR/hmi
        ERROR=$?
        chmod 754 $LOCAL_APP_DIR/hmi
     else
          ERROR=1
     fi
   fi

    # FCRTS
    if [ "$FCRTS" = "1" ]; then
        MSG="runtime update"
        if [ -s $TMPOUT.1 ]; then
            mv $TMPOUT.1 $LOCAL_APP_DIR/fcrts
            ERROR=$?
            chmod 754 $LOCAL_APP_DIR/fcrts
        else
            ERROR=1
        fi
    fi

    if [ "$PLC" = "1" ]; then
        MSG="PLC program update"
          if [ -s $TMPOUT.1 ]; then
            mv $TMPOUT.1 /local/control.tar.gz
            cd /local
            tar xzf /local/control.tar.gz
            ERROR=$?
			rm -f /local/control.tar.gz
            cd -
          else
              ERROR=1
          fi
    fi
    if [ "$CROSSTBL" = "1" ]; then
        MSG="Cross table"
          if [ -s $TMPOUT.1 ]; then
            mv $TMPOUT.1 $LOCAL_ETC_DIR/Crosstable.csv.tmp
            ERROR=$?
            chmod 644 $LOCAL_ETC_DIR/Crosstable.csv.tmp
            /usr/bin/dos2unix $LOCAL_ETC_DIR/Crosstable.csv.tmp
	    if diff Crosstable.csv.tmp Crosstable.csv >/dev/null; then
		#echo "SAME"
		mv $LOCAL_ETC_DIR/Crosstable.csv.tmp $LOCAL_ETC_DIR/Crosstable.csv
                chmod 644 $LOCAL_ETC_DIR/Crosstable.csv
	    else
		#echo "DIFFERENT"
#		/etc/rc.d/init.d/autoexec stop > /dev/null 2>&1
		LOG="`date '+%Y_%m_%d'`.log"
		if [ -e "$BASE_DIR/$STORE_DIR/$LOG" ]; then
			mv "$BASE_DIR/$STORE_DIR/$LOG" "$BASE_DIR/$STORE_DIR/`date '+%Y_%m_%d'`_`date '+%H%M%S'`.log"
		fi		
		mv $LOCAL_ETC_DIR/Crosstable.csv.tmp $LOCAL_ETC_DIR/Crosstable.csv
                chmod 644 $LOCAL_ETC_DIR/Crosstable.csv
	    fi
          else
              ERROR=1
        fi
    fi
    if [ "$TAGTBL" = "1" ]; then
        MSG="Tag table"
          if [ -s $TMPOUT.1 ]; then
            mv $TMPOUT.1 $LOCAL_ETC_DIR/Tags_Table.csv.tmp
            ERROR=$?
            chmod 644 $LOCAL_ETC_DIR/Tags_Table.csv.tmp
            /usr/bin/dos2unix $LOCAL_ETC_DIR/Tags_Table.csv.tmp
	    if diff Tags_Table.csv.tmp Tags_Table.csv >/dev/null; then
		#echo "SAME"
		mv $LOCAL_ETC_DIR/Tags_Table.csv.tmp $LOCAL_ETC_DIR/Tags_Table.csv
                chmod 644 $LOCAL_ETC_DIR/Tags_Table.csv
	    else
		#echo "DIFFERENT"
#		/etc/rc.d/init.d/autoexec stop > /dev/null 2>&1
		LOG="`date '+%Y_%m_%d'`.log"
		if [ -e "$BASE_DIR/$STORE_DIR/$LOG" ]; then
			mv "$BASE_DIR/$STORE_DIR/$LOG" "$BASE_DIR/$STORE_DIR/`date '+%Y_%m_%d'`_`date '+%H%M%S'`.log"
		fi		
		mv $LOCAL_ETC_DIR/Tags_Table.csv.tmp $LOCAL_ETC_DIR/Tags_Table.csv
                chmod 644 $LOCAL_ETC_DIR/Tags_Table.csv
	    fi
          else
              ERROR=1
        fi
    fi
    if [ "$ALARMTBL" = "1" ]; then
        MSG="Alarm table"
          if [ -s $TMPOUT.1 ]; then
            mv $TMPOUT.1 $LOCAL_ETC_DIR/Alarms.csv
            ERROR=$?
            chmod 644 $LOCAL_ETC_DIR/Alarms.csv
            /usr/bin/dos2unix $LOCAL_ETC_DIR/Alarms.csv
          else
              ERROR=1
        fi
    fi
    if [ "$CFGTBL" = "1" ]; then
        MSG="Communication Config table"
          if [ -s $TMPOUT.1 ]; then
            mv $TMPOUT.1 $LOCAL_ETC_DIR/Commpar.csv
            ERROR=$?
            chmod 644 $LOCAL_ETC_DIR/Commpar.csv
            /usr/bin/dos2unix $LOCAL_ETC_DIR/Commpar.csv
          else
              ERROR=1
        fi
    fi
    if [ "$ATNCFG" = "1" ]; then
        MSG="Application Config"
          if [ -s $TMPOUT.1 ]; then
            mv $TMPOUT.1 $LOCAL_ETC_DIR/atn01.conf
            ERROR=$?
            chmod 644 $LOCAL_ETC_DIR/atn01.conf
            /usr/bin/dos2unix $LOCAL_ETC_DIR/atn01.conf
          else
              ERROR=1
        fi
    fi
    if [ "$RCPTBL" = "1" ]; then
        MSG="Recipe '$FILENAME'"
          if [ "$FILENAME" != "" ] && [ -s $TMPOUT.1 ]; then
            mv $TMPOUT.1 $BASE_DIR/$RECIPE_DIR/$FILENAME
            ERROR=$?
            chmod 644 $BASE_DIR/$RECIPE_DIR/$FILENAME
            /usr/bin/dos2unix $BASE_DIR/$RECIPE_DIR/$FILENAME
          else
              ERROR=1
        fi
    fi
    if [ "$RCPZIP" = "1" ]; then
        MSG="Recipe zip file"
          if [ -s $TMPOUT.1 ]; then
            mv $TMPOUT.1 $BASE_DIR/$RECIPE_DIR/.recipes.zip
            cd $BASE_DIR/$RECIPE_DIR
            /usr/bin/unzip -o $BASE_DIR/$RECIPE_DIR/.recipes.zip
            ERROR=$?
            cd -
            rm -f $BASE_DIR/$RECIPE_DIR/.recipes.zip
            chmod 644 $BASE_DIR/$RECIPE_DIR/*/*.csv
            /usr/bin/dos2unix $BASE_DIR/$RECIPE_DIR/*/*.csv
          else
              ERROR=1
        fi
    fi
    if [ "$CFGZIP" = "1" ]; then
        MSG="Config zip file"
          if [ -s $TMPOUT.1 ]; then
            mv $TMPOUT.1 $BASE_DIR/.config.zip
            cd $BASE_DIR
            /usr/bin/unzip -o $BASE_DIR/.config.zip
            ERROR=$?
            cd -
            rm -f $BASE_DIR/.config.zip
			#Check if the CONFIG_DIR name beside being the expected uses upper case
			EXTRACT_DIR=`ls /local/data/ | grep -i $CONFIG_DIR`
			if [ "$EXTRACT_DIR" == "" ] 
			then
              ERROR=1
			else
				if [ "$EXTRACT_DIR" != "$CONFIG_DIR" ]
				then
					mkdir -p $BASE_DIR/$CONFIG_DIR
					mv $BASE_DIR/$EXTRACT_DIR/* $BASE_DIR/$CONFIG_DIR
					rm -rf $BASE_DIR/$EXTRACT_DIR
				fi
			fi
          else
              ERROR=1
        fi
    fi
    if [ "$LOGSTBL" = "1" ]; then
        MSG="Partial logs '$FILENAME'"
          if [ "$FILENAME" != "" ] && [ -s $TMPOUT.1 ]; then
            mv $TMPOUT.1 $BASE_DIR/$PARTIAL_STORE_DIR/$FILENAME
            ERROR=$?
            chmod 644 $BASE_DIR/$PARTIAL_STORE_DIR/$FILENAME
            /usr/bin/dos2unix $BASE_DIR/$PARTIAL_STORE_DIR/$FILENAME
          else
              ERROR=1
        fi
    fi
    if [ "$TRENDTBL" = "1" ]; then
        MSG="Trend '$FILENAME'"
          if [ "$FILENAME" != "" ] && [ -s $TMPOUT.1 ]; then
            mv $TMPOUT.1 $BASE_DIR/customtrend/$FILENAME
            ERROR=$?
            chmod 644 $BASE_DIR/customtrend/$FILENAME
            /usr/bin/dos2unix $BASE_DIR/customtrend/$FILENAME
          else
              ERROR=1
        fi
    fi
    if [ "$SPLASH" = "1" ]; then
        MSG="Splash File"
          if [ -s $TMPOUT.1 ]; then
            mv $TMPOUT.1 $LOCAL_ETC_DIR/img/splash.png
            ERROR=$?
            chmod 644 $LOCAL_ETC_DIR/img/splash.png
          else
              ERROR=1
        fi
    fi
  else
  	ERROR=1
	rm -f $TMPOUT.1
    MSG="Empty file"
  fi
fi

cat <<EOF
Content-Type: text/html

<html>
<head>
<title>$TARGET_NAME REMOTE UPDATER</title>
<link rel="stylesheet" type="text/css" href="style.css">
</head>
<body>
<div id="container">
<div id="header">
<table width="100%">
<tr align="right">
<td>
EOF
. ./info.cgi
cat <<EOF
</td>
</tr>
<tr>
<td>
<h1>$TARGET_NAME REMOTE UPDATER</h1>
</td>
</tr>
</table>
</div>
<div id="content">
EOF

if [ $ERROR != 0 ]
then
cat <<EOF
<table style="border:solid 2px #FF0000;" bgcolor=#fffbff cellspacing=10 cellpadding=4 align=center >
<tbody>
<tr>
<td>
Fail to upload $MSG
</td>
</tr>
EOF
else
cat <<EOF
<table style="border:solid 2px #335970;" bgcolor=#f1fbff cellspacing=10 cellpadding=4 align=center >
<tbody>
<tr>
<td>
    Success to upload $MSG.
EOF
cat <<EOF
</td>
</tr>
EOF
fi

#    if [ "$RCPTBL" != "1" ] && [ "$RCPZIP" != "1" ] && [ "$LOGSTBL" != "1" ] && [ "$TRENDTBL" != "1" ]; then
	if [ -x /local/root/splash ]
	then
		killall splash
	fi
		/etc/rc.d/init.d/autoexec start > /dev/null 2>&1
        echo "Restarting the application."
#    fi

cat <<EOF
<tr>
<td>
<center>
<form>
 <input class=bottoni type="button" value="Home" onclick="window.location.href='menu.cgi'">
EOF
    if [ "$RCPTBL" != "1" ] && [ "$RCPZIP" != "1" ] && [ "$LOGSTBL" != "1" ] && [ "$TRENDTBL" != "1" ]; then
        echo "<input class=bottoni type=\"button\" value=\"Restart\" onclick=\"window.location.href='reboot.cgi?COMMAND=RESTART'\">"
        echo "<input class=bottoni type=\"button\" value=\"Reboot\" onclick=\"window.location.href='reboot.cgi?COMMAND=REBOOT'\">"
    fi
cat <<EOF
</form>
</center>
</td>
</tr>

</tbody>
</table>
</div>                                                                                
</div>                                                                                
<div id="footer"><h2>$COMANY_NAME</h2></div> 
</body>
</html>
EOF

rm -f $TMPOUT $TMPOUT.1
sync
